"""Stub file for reflex_enterprise/components/ag_grid/aggrid.py"""

# ------------------- DO NOT EDIT ----------------------
# This file was generated by `reflex/utils/pyi_generator.py`!
# ------------------------------------------------------
from typing import Any, Callable, Literal, Optional, overload

import reflex as rx
from reflex.event import EventSpec, EventType
from reflex.style import Style
from reflex.vars.base import Var
from reflex.vars.function import ArgsFunctionOperation

from reflex_enterprise.components.component import ComponentEnterprise

from .datasource import Datasource, SSRMDatasource
from .resource import (
    AGEditors,
    AGFilters,
    AGRenderers,
    ColumnDef,
    ColumnGroup,
    value_func_factory,
)

AG_GRID_VERSION = "32.3.0"

def arrow_callback(js_expr: str | list[str]): ...
def exclude_non_serializable_keys(
    event: Var, exclude_keys: list[str], log_event: bool = False
) -> list[str]: ...

_size_columns_to_fit = ArgsFunctionOperation.create(
    args_names=("event",),
    return_expr=Var("(event) => event.api.sizeColumnsToFit()"),
    _var_type=rx.EventChain,
)

class AgGridAPI(rx.Base):
    ref: str

    @classmethod
    def create(cls, id: str) -> "AgGridAPI": ...  # type: ignore

class AgGrid(ComponentEnterprise):
    @overload
    @classmethod
    def create(  # type: ignore
        cls,
        *children,
        id: str | None,
        data_path_key: str | None = None,
        is_server_side_group_key: str | None = None,
        server_side_group_key: str | None = None,
        server_side_group_open_level: int | None = None,
        child_count_key: str | None = None,
        row_id_key: str | None = None,
        column_defs: Var[list[ColumnDef | ColumnGroup | dict[str, Any]]]
        | list[ColumnDef | ColumnGroup | dict[str, Any]]
        | None = None,
        row_data: Var[list[dict[str, Any]]] | list[dict[str, Any]] | None = None,
        column_types: Var[dict[str, Any]] | dict[str, Any] | None = None,
        cell_selection: Var[bool] | bool | None = None,
        row_selection: Var[str] | str | None = None,
        animate_rows: Var[bool] | bool | None = None,
        pagination: Var[bool] | bool | None = None,
        pagination_page_size: Var[int] | int | None = None,
        auto_size_strategy: Var[dict] | dict | None = None,
        pagination_page_size_selector: Var[list[int]] | list[int] | None = None,
        side_bar: Var[bool | dict[str, Any] | list[str] | str]
        | bool
        | dict[str, Any]
        | list[str]
        | str
        | None = None,
        tree_data: Var[bool] | bool | None = None,
        default_col_def: Var[dict[str, Any]] | dict[str, Any] | None = None,
        auto_group_column_def: Any | Var[Any] | None = None,
        pinned_top_row_data: Var[list[dict[str, Any]]]
        | list[dict[str, Any]]
        | None = None,
        pinned_bottom_row_data: Var[list[dict[str, Any]]]
        | list[dict[str, Any]]
        | None = None,
        group_default_expanded: Var[int] | int | int | None = None,
        group_selects_children: Var[bool] | bool | None = None,
        suppress_row_click_selection: Var[bool] | bool | None = None,
        get_data_path: Callable | Var[Callable] | None = None,
        group_allow_unbalanced: Var[bool] | bool | None = None,
        pivot_mode: Var[bool] | bool | None = None,
        pivot_panel_show: Var[str] | str | None = None,
        row_group_panel_show: Var[str] | str | None = None,
        suppress_agg_func_in_header: Var[bool] | bool | None = None,
        group_lock_group_columns: Var[int] | int | None = None,
        maintain_column_order: Var[bool] | bool | None = None,
        row_model_type: Var[str] | str | None = None,
        cache_block_size: Var[int] | int | None = None,
        max_blocks_in_cache: Var[int] | int | None = None,
        row_buffer: Var[int] | int | None = None,
        cache_overflow_size: Var[int] | int | None = None,
        max_concurrent_datasource_requests: Var[int] | int | None = None,
        infinite_initial_row_count: Var[int] | int | None = None,
        datasource: Datasource | Var[Datasource] | None = None,
        server_side_datasource: SSRMDatasource | Var[SSRMDatasource] | None = None,
        server_side_enable_client_side_sort: Var[bool] | bool | None = None,
        theme: Literal["alpine", "balham", "material", "quartz"]
        | Var[Literal["alpine", "balham", "material", "quartz"]]
        | None = None,
        style: Style | None = None,
        key: Any | None = None,
        class_name: Any | None = None,
        autofocus: bool | None = None,
        custom_attrs: dict[str, Var | Any] | None = None,
        get_child_count: Optional[EventType[Any]] = None,
        get_row_id: Optional[EventType[Any]] = None,
        get_server_side_group_key: Optional[EventType[Any]] = None,
        is_server_side_group: Optional[EventType[Any]] = None,
        is_server_side_group_open_by_default: Optional[EventType[Any]] = None,
        on_blur: Optional[EventType[()]] = None,
        on_cell_clicked: Optional[EventType[Any]] = None,
        on_cell_context_menu: Optional[EventType[Any]] = None,
        on_cell_double_clicked: Optional[EventType[Any]] = None,
        on_cell_focused: Optional[EventType[Any]] = None,
        on_cell_mouse_out: Optional[EventType[Any]] = None,
        on_cell_mouse_over: Optional[EventType[Any]] = None,
        on_cell_value_changed: Optional[EventType[Any]] = None,
        on_click: Optional[EventType[()]] = None,
        on_column_header_clicked: Optional[EventType[Any]] = None,
        on_column_header_context_menu: Optional[EventType[Any]] = None,
        on_column_moved: Optional[EventType[Any]] = None,
        on_column_pinned: Optional[EventType[Any]] = None,
        on_column_resized: Optional[EventType[Any]] = None,
        on_context_menu: Optional[EventType[()]] = None,
        on_double_click: Optional[EventType[()]] = None,
        on_first_data_rendered: Optional[EventType[Any]] = None,
        on_focus: Optional[EventType[()]] = None,
        on_grid_ready: Optional[EventType[Any]] = None,
        on_header_focused: Optional[EventType[Any]] = None,
        on_mount: Optional[EventType[()]] = None,
        on_mouse_down: Optional[EventType[()]] = None,
        on_mouse_enter: Optional[EventType[()]] = None,
        on_mouse_leave: Optional[EventType[()]] = None,
        on_mouse_move: Optional[EventType[()]] = None,
        on_mouse_out: Optional[EventType[()]] = None,
        on_mouse_over: Optional[EventType[()]] = None,
        on_mouse_up: Optional[EventType[()]] = None,
        on_row_clicked: Optional[EventType[Any]] = None,
        on_row_double_clicked: Optional[EventType[Any]] = None,
        on_row_selected: Optional[EventType[Any]] = None,
        on_scroll: Optional[EventType[()]] = None,
        on_selection_changed: Optional[EventType[Any]] = None,
        on_unmount: Optional[EventType[()]] = None,
        **props,
    ) -> "AgGrid":
        """Create an instance of the AgGrid component."""
        ...

    def add_imports(self): ...
    def add_custom_code(self) -> list[str]: ...
    @property
    def api(self) -> AgGridAPI: ...
    def get_selected_rows(self, callback: rx.EventHandler) -> EventSpec: ...
    def select_all(self) -> EventSpec: ...
    def deselect_all(self) -> EventSpec: ...
    def select_rows_by_key(self, keys: list[str]) -> EventSpec: ...
    def log_nodes(self) -> EventSpec: ...
    def setGridOption(self, key: str, value: Var) -> EventSpec: ...
    def set_datasource(self, datasource: Datasource): ...
    def set_serverside_datasource(self, datasource: SSRMDatasource): ...
    def show_loading_overlay(self) -> EventSpec: ...
    def show_no_rows_overlay(self) -> EventSpec: ...
    def hide_overlay(self) -> EventSpec: ...
    def redraw_rows(self) -> EventSpec: ...
    def export_data_as_csv(self) -> EventSpec: ...

class WrappedAgGrid(AgGrid):
    @overload
    @classmethod
    def create(  # type: ignore
        cls,
        *children,
        column_defs: Var[list[ColumnDef | ColumnGroup | dict[str, Any]]]
        | list[ColumnDef | ColumnGroup | dict[str, Any]]
        | None = None,
        row_data: Var[list[dict[str, Any]]] | list[dict[str, Any]] | None = None,
        column_types: Var[dict[str, Any]] | dict[str, Any] | None = None,
        cell_selection: Var[bool] | bool | None = None,
        row_selection: Var[str] | str | None = None,
        animate_rows: Var[bool] | bool | None = None,
        pagination: Var[bool] | bool | None = None,
        pagination_page_size: Var[int] | int | None = None,
        auto_size_strategy: Var[dict] | dict | None = None,
        pagination_page_size_selector: Var[list[int]] | list[int] | None = None,
        side_bar: Var[bool | dict[str, Any] | list[str] | str]
        | bool
        | dict[str, Any]
        | list[str]
        | str
        | None = None,
        tree_data: Var[bool] | bool | None = None,
        default_col_def: Var[dict[str, Any]] | dict[str, Any] | None = None,
        auto_group_column_def: Any | Var[Any] | None = None,
        pinned_top_row_data: Var[list[dict[str, Any]]]
        | list[dict[str, Any]]
        | None = None,
        pinned_bottom_row_data: Var[list[dict[str, Any]]]
        | list[dict[str, Any]]
        | None = None,
        group_default_expanded: Var[int] | int | int | None = None,
        group_selects_children: Var[bool] | bool | None = None,
        suppress_row_click_selection: Var[bool] | bool | None = None,
        get_data_path: Callable | Var[Callable] | None = None,
        group_allow_unbalanced: Var[bool] | bool | None = None,
        pivot_mode: Var[bool] | bool | None = None,
        pivot_panel_show: Var[str] | str | None = None,
        row_group_panel_show: Var[str] | str | None = None,
        suppress_agg_func_in_header: Var[bool] | bool | None = None,
        group_lock_group_columns: Var[int] | int | None = None,
        maintain_column_order: Var[bool] | bool | None = None,
        row_model_type: Var[str] | str | None = None,
        cache_block_size: Var[int] | int | None = None,
        max_blocks_in_cache: Var[int] | int | None = None,
        row_buffer: Var[int] | int | None = None,
        cache_overflow_size: Var[int] | int | None = None,
        max_concurrent_datasource_requests: Var[int] | int | None = None,
        infinite_initial_row_count: Var[int] | int | None = None,
        datasource: Datasource | Var[Datasource] | None = None,
        server_side_datasource: SSRMDatasource | Var[SSRMDatasource] | None = None,
        server_side_enable_client_side_sort: Var[bool] | bool | None = None,
        theme: Literal["alpine", "balham", "material", "quartz"]
        | Var[Literal["alpine", "balham", "material", "quartz"]]
        | None = None,
        style: Style | None = None,
        key: Any | None = None,
        id: Any | None = None,
        class_name: Any | None = None,
        autofocus: bool | None = None,
        custom_attrs: dict[str, Var | Any] | None = None,
        get_child_count: Optional[EventType[Any]] = None,
        get_row_id: Optional[EventType[Any]] = None,
        get_server_side_group_key: Optional[EventType[Any]] = None,
        is_server_side_group: Optional[EventType[Any]] = None,
        is_server_side_group_open_by_default: Optional[EventType[Any]] = None,
        on_blur: Optional[EventType[()]] = None,
        on_cell_clicked: Optional[EventType[Any]] = None,
        on_cell_context_menu: Optional[EventType[Any]] = None,
        on_cell_double_clicked: Optional[EventType[Any]] = None,
        on_cell_focused: Optional[EventType[Any]] = None,
        on_cell_mouse_out: Optional[EventType[Any]] = None,
        on_cell_mouse_over: Optional[EventType[Any]] = None,
        on_cell_value_changed: Optional[EventType[Any]] = None,
        on_click: Optional[EventType[()]] = None,
        on_column_header_clicked: Optional[EventType[Any]] = None,
        on_column_header_context_menu: Optional[EventType[Any]] = None,
        on_column_moved: Optional[EventType[Any]] = None,
        on_column_pinned: Optional[EventType[Any]] = None,
        on_column_resized: Optional[EventType[Any]] = None,
        on_context_menu: Optional[EventType[()]] = None,
        on_double_click: Optional[EventType[()]] = None,
        on_first_data_rendered: Optional[EventType[Any]] = None,
        on_focus: Optional[EventType[()]] = None,
        on_grid_ready: Optional[EventType[Any]] = None,
        on_header_focused: Optional[EventType[Any]] = None,
        on_mount: Optional[EventType[()]] = None,
        on_mouse_down: Optional[EventType[()]] = None,
        on_mouse_enter: Optional[EventType[()]] = None,
        on_mouse_leave: Optional[EventType[()]] = None,
        on_mouse_move: Optional[EventType[()]] = None,
        on_mouse_out: Optional[EventType[()]] = None,
        on_mouse_over: Optional[EventType[()]] = None,
        on_mouse_up: Optional[EventType[()]] = None,
        on_row_clicked: Optional[EventType[Any]] = None,
        on_row_double_clicked: Optional[EventType[Any]] = None,
        on_row_selected: Optional[EventType[Any]] = None,
        on_scroll: Optional[EventType[()]] = None,
        on_selection_changed: Optional[EventType[Any]] = None,
        on_unmount: Optional[EventType[()]] = None,
        **props,
    ) -> "WrappedAgGrid":
        """Create an instance of the AgGrid component with good default dimensions."""
        ...

class AgGridNamespace(rx.ComponentNamespace):
    api = AgGridAPI.create
    column_def = ColumnDef
    column_group = ColumnGroup
    filters = AGFilters
    editors = AGEditors
    renderers = AGRenderers
    size_columns_to_fit = _size_columns_to_fit
    value_func_factory = staticmethod(value_func_factory)
    root = AgGrid.create

    @staticmethod
    def __call__(
        *children,
        column_defs: Var[list[ColumnDef | ColumnGroup | dict[str, Any]]]
        | list[ColumnDef | ColumnGroup | dict[str, Any]]
        | None = None,
        row_data: Var[list[dict[str, Any]]] | list[dict[str, Any]] | None = None,
        column_types: Var[dict[str, Any]] | dict[str, Any] | None = None,
        cell_selection: Var[bool] | bool | None = None,
        row_selection: Var[str] | str | None = None,
        animate_rows: Var[bool] | bool | None = None,
        pagination: Var[bool] | bool | None = None,
        pagination_page_size: Var[int] | int | None = None,
        auto_size_strategy: Var[dict] | dict | None = None,
        pagination_page_size_selector: Var[list[int]] | list[int] | None = None,
        side_bar: Var[bool | dict[str, Any] | list[str] | str]
        | bool
        | dict[str, Any]
        | list[str]
        | str
        | None = None,
        tree_data: Var[bool] | bool | None = None,
        default_col_def: Var[dict[str, Any]] | dict[str, Any] | None = None,
        auto_group_column_def: Any | Var[Any] | None = None,
        pinned_top_row_data: Var[list[dict[str, Any]]]
        | list[dict[str, Any]]
        | None = None,
        pinned_bottom_row_data: Var[list[dict[str, Any]]]
        | list[dict[str, Any]]
        | None = None,
        group_default_expanded: Var[int] | int | int | None = None,
        group_selects_children: Var[bool] | bool | None = None,
        suppress_row_click_selection: Var[bool] | bool | None = None,
        get_data_path: Callable | Var[Callable] | None = None,
        group_allow_unbalanced: Var[bool] | bool | None = None,
        pivot_mode: Var[bool] | bool | None = None,
        pivot_panel_show: Var[str] | str | None = None,
        row_group_panel_show: Var[str] | str | None = None,
        suppress_agg_func_in_header: Var[bool] | bool | None = None,
        group_lock_group_columns: Var[int] | int | None = None,
        maintain_column_order: Var[bool] | bool | None = None,
        row_model_type: Var[str] | str | None = None,
        cache_block_size: Var[int] | int | None = None,
        max_blocks_in_cache: Var[int] | int | None = None,
        row_buffer: Var[int] | int | None = None,
        cache_overflow_size: Var[int] | int | None = None,
        max_concurrent_datasource_requests: Var[int] | int | None = None,
        infinite_initial_row_count: Var[int] | int | None = None,
        datasource: Datasource | Var[Datasource] | None = None,
        server_side_datasource: SSRMDatasource | Var[SSRMDatasource] | None = None,
        server_side_enable_client_side_sort: Var[bool] | bool | None = None,
        theme: Literal["alpine", "balham", "material", "quartz"]
        | Var[Literal["alpine", "balham", "material", "quartz"]]
        | None = None,
        style: Style | None = None,
        key: Any | None = None,
        id: Any | None = None,
        class_name: Any | None = None,
        autofocus: bool | None = None,
        custom_attrs: dict[str, Var | Any] | None = None,
        get_child_count: Optional[EventType[Any]] = None,
        get_row_id: Optional[EventType[Any]] = None,
        get_server_side_group_key: Optional[EventType[Any]] = None,
        is_server_side_group: Optional[EventType[Any]] = None,
        is_server_side_group_open_by_default: Optional[EventType[Any]] = None,
        on_blur: Optional[EventType[()]] = None,
        on_cell_clicked: Optional[EventType[Any]] = None,
        on_cell_context_menu: Optional[EventType[Any]] = None,
        on_cell_double_clicked: Optional[EventType[Any]] = None,
        on_cell_focused: Optional[EventType[Any]] = None,
        on_cell_mouse_out: Optional[EventType[Any]] = None,
        on_cell_mouse_over: Optional[EventType[Any]] = None,
        on_cell_value_changed: Optional[EventType[Any]] = None,
        on_click: Optional[EventType[()]] = None,
        on_column_header_clicked: Optional[EventType[Any]] = None,
        on_column_header_context_menu: Optional[EventType[Any]] = None,
        on_column_moved: Optional[EventType[Any]] = None,
        on_column_pinned: Optional[EventType[Any]] = None,
        on_column_resized: Optional[EventType[Any]] = None,
        on_context_menu: Optional[EventType[()]] = None,
        on_double_click: Optional[EventType[()]] = None,
        on_first_data_rendered: Optional[EventType[Any]] = None,
        on_focus: Optional[EventType[()]] = None,
        on_grid_ready: Optional[EventType[Any]] = None,
        on_header_focused: Optional[EventType[Any]] = None,
        on_mount: Optional[EventType[()]] = None,
        on_mouse_down: Optional[EventType[()]] = None,
        on_mouse_enter: Optional[EventType[()]] = None,
        on_mouse_leave: Optional[EventType[()]] = None,
        on_mouse_move: Optional[EventType[()]] = None,
        on_mouse_out: Optional[EventType[()]] = None,
        on_mouse_over: Optional[EventType[()]] = None,
        on_mouse_up: Optional[EventType[()]] = None,
        on_row_clicked: Optional[EventType[Any]] = None,
        on_row_double_clicked: Optional[EventType[Any]] = None,
        on_row_selected: Optional[EventType[Any]] = None,
        on_scroll: Optional[EventType[()]] = None,
        on_selection_changed: Optional[EventType[Any]] = None,
        on_unmount: Optional[EventType[()]] = None,
        **props,
    ) -> "WrappedAgGrid":
        """Create an instance of the AgGrid component with good default dimensions."""
        ...

ag_grid = AgGridNamespace()
